# frozen_string_literal: true
namespace :rdms do
  desc "Fix object key structure in S3. usage: rdms:remove_files_folders_form_s3"
  task remove_files_folders_from_s3: :environment do
    s3 = S3StorageService.new
    s3.init_client

    s3.list_buckets.each do |bucket|
      if bucket[:name].start_with?("#{ENV['S3_BUCKET_PREFIX']}-".downcase.gsub(/[^0-9a-z.-]/, ''))
        list_of_objects, total_size = s3.list_all_objects(bucket[:name])
        list_of_objects.each do |object|
          if object[:key].include?('/files') or object[:key].include?('//')
            s3.move_object(object[:key], bucket[:name], object[:key].gsub('/files', '').gsub('//', '/'), {}, bucket[:name])
          end
        end
      end
    end
  end
end